curl --request POST \
--url https://api.axiom.xyz/v1/programs \
--header 'Axiom-API-Key: <api-key>' \
--header 'Content-Type: multipart/form-data' \
--form elf='@example-file' \
--form vmexe='@example-file'import requests
url = "https://api.axiom.xyz/v1/programs"
files = {
"elf": ("example-file", open("example-file", "rb")),
"vmexe": ("example-file", open("example-file", "rb"))
}
headers = {"Axiom-API-Key": "<api-key>"}
response = requests.post(url, files=files, headers=headers)
print(response.text)const form = new FormData();
form.append('elf', '<string>');
form.append('vmexe', '<string>');
const options = {method: 'POST', headers: {'Axiom-API-Key': '<api-key>'}};
options.body = form;
fetch('https://api.axiom.xyz/v1/programs', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"id": "<string>"
}{
"id": "<string>"
}{
"detail": [
{
"loc": [
"<string>"
],
"msg": "<string>",
"type": "<string>"
}
]
}Register new program
Register a new OpenVM program from pre-built artifacts.
Build the program locally with cargo openvm build, then upload the resulting ELF
binary together with the transpiled VMEXE. The backend computes the program’s
exe_commit and verification baseline asynchronously (via a lightweight Kubernetes job)
and flips the program to Ready — no cloud compilation happens.
Example Usage
curl -X POST "https://api.axiom.xyz/v1/programs?config_id=cfg_xxxx" \
-H "Axiom-API-Key: your-api-key" \
-F "elf=@program.elf" \
-F "vmexe=@program.vmexe" \
-F "project_name=My Project"
Authorizations
Query Parameters
The ID of the config to use (format: cfg_{ulid})
Optional custom name for the program
If applicable, the commit sha of the guest program
The ID of the project to associate this program with. If not provided, a new project will be created.
Name for new project if project_id is not provided
Default number of GPUs to use for proofs of this program
1 <= x <= 10000Response
Successful Response
Generic response for POST operations.
Was this page helpful?